<?php
	
if ( is_user_logged_in() )
{	
	
	$min_rights	= 'activate_plugins';
	
	// Si l'utilisateur n'est pas administrateur
	if ( ! current_user_can( $min_rights ) )
	{
		// Retirer les cadres du dashboard
		add_action( 'admin_init', 'mgrm_remove_dashboard_meta' );
		function mgrm_remove_dashboard_meta()
		{
			remove_action( 'welcome_panel', 'wp_welcome_panel' );
			//remove_meta_box( 'dashboard_plugins', 'dashboard', 'normal' );
			remove_meta_box( 'dashboard_primary', 'dashboard', 'normal' );
			//remove_meta_box( 'dashboard_secondary', 'dashboard', 'normal' );
			//remove_meta_box( 'dashboard_incoming_links', 'dashboard', 'normal' );
			//remove_meta_box( 'dashboard_quick_press', 'dashboard', 'side' );
			//remove_meta_box( 'dashboard_recent_drafts', 'dashboard', 'side' );
			//remove_meta_box( 'dashboard_latest_comments', 'dashboard', 'normal' );
			//remove_meta_box( 'dashboard_right_now', 'dashboard', 'normal' );
		
		
			// Ajouter la gestion des menu aux editeurs
			$role_object = get_role( 'editor' );
			$role_object->add_cap( 'edit_theme_options' );
		}
		
		
		// Virer certains menus
		add_action( 'admin_menu', 'mgrm_remove_admin_menu_pages' );
		function mgrm_remove_admin_menu_pages()
		{
			remove_menu_page( 'edit-comments.php' );
			remove_menu_page( 'tools.php' );
			
			// Laisser le menu theme pour les editeurs
			if ( !current_user_can( 'delete_others_pages' ) )
			{
				remove_menu_page( 'themes.php' );
			}
			remove_submenu_page( 'themes.php', 'themes.php' );
			remove_submenu_page( 'themes.php', add_query_arg( 'return', urlencode( wp_unslash( $_SERVER['REQUEST_URI'] ) ), 'customize.php' ) );
		}
		
		
		// Rtirer des liens dans la barre d'admin
		add_action( 'wp_before_admin_bar_render', 'mgrm_remove_admin_bar_links' );
		function mgrm_remove_admin_bar_links()
		{
		    global $wp_admin_bar;
		    $wp_admin_bar->remove_menu('wp-logo');          // Remove the WordPress logo
		    //$wp_admin_bar->remove_menu('about');            // Remove the about WordPress link
		    //$wp_admin_bar->remove_menu('wporg');            // Remove the WordPress.org link
		    //$wp_admin_bar->remove_menu('documentation');    // Remove the WordPress documentation link
		    //$wp_admin_bar->remove_menu('support-forums');   // Remove the support forums link
		    //$wp_admin_bar->remove_menu('feedback');         // Remove the feedback link
		    //$wp_admin_bar->remove_menu('site-name');        // Remove the site name menu
		    //$wp_admin_bar->remove_menu('view-site');        // Remove the view site link
		    //$wp_admin_bar->remove_menu('updates');          // Remove the updates link
		    $wp_admin_bar->remove_menu('comments');         // Remove the comments link
		    //$wp_admin_bar->remove_menu('new-content');      // Remove the content link
		    //$wp_admin_bar->remove_menu('w3tc');             // If you use w3 total cache remove the performance link
		    //$wp_admin_bar->remove_menu('my-account');       // Remove the user details tab
		    $wp_admin_bar->remove_menu('appearance');		// Remove appearance links from dashboard tab
		    $wp_admin_bar->remove_menu('customize');
		}
		
		
		// Retirer des colonnes dans les articles
		add_filter( 'manage_edit-post_columns', 'mgrm_columns_filter', 10, 1 );
		function mgrm_columns_filter( $columns )
		{
			//unset( $columns[ 'author' ] );
			//unset( $columns[ 'categories' ] );
			//unset( $columns[ 'tags' ] );
			unset( $columns[ 'comments' ] );
			
			return $columns;
		}
		
		
		// Retirer les commentaire et la version du cadre "d'un coup d'oeil"
		add_action('admin_head', 'mgrm_dashboard_right_now');
		function mgrm_dashboard_right_now()
		{
			echo '<style type="text/css">
				#dashboard_right_now .comment-count, #wp-version-message { display: none !important; }
			</style>';
		}
		
		
		// Retirer les commentaire du cadre "activité"
		add_action('admin_head', 'mgrm_dashboard_activity');
		function mgrm_dashboard_activity()
		{
			echo '<style type="text/css">
				#dashboard_activity #latest-comments { display: none !important; }
			</style>';
		}
		
		
		// Retirer l'onglet aide
		add_action('admin_head', 'mgrm_hide_help_tab');
		function mgrm_hide_help_tab()
		{
			echo '<style type="text/css">
			        #contextual-help-link-wrap { display: none !important; }
			</style>';
		}
		
		
		// Retirer le remerciements du footer
		add_filter('admin_footer_text', 'mgrm_dashboard_footer', 9999);
		function mgrm_dashboard_footer () {}
		
		
		// Retirer la version du footer
		add_filter('update_footer', 'mgrm_dashboard_footer_version', 9999);
		function mgrm_dashboard_footer_version () {}
		
		
		// Retirer le bouton de personnalisation dans la page menu
		add_action('admin_head', 'mgrm_hide_menu_screen_customize_button');
		function mgrm_hide_menu_screen_customize_button()
		{
			echo '<style type="text/css">
			        .nav-menus-php .hide-if-no-customize { display: none !important; }
			</style>';
		}
		
		
		// Retirer l'onglet gérer les emplacement dans la page menu
		// Retirer le lien pour créer un menu
		add_action('admin_head', 'mgrm_hide_menu_unnecessary');
		function mgrm_hide_menu_unnecessary()
		{
			echo '<style type="text/css">
			        .nav-menus-php .nav-tab-wrapper,
			        .nav-menus-php .manage-menus,
			        .nav-menus-php .delete-action,
			        .nav-menus-php .menu-theme-locations { display: none !important; }
			</style>';
		}
	}
}


// Retirer le logo du formulaire de connexion à l'admin
function mgrm_login_logo() { ?>
    <style type="text/css">
        .login h1 { display: none; }
    </style>
<?php }
add_action( 'login_enqueue_scripts', 'mgrm_login_logo' );