<?php

$mgrm_bloc_home		= new mgrm_bloc_home;

class mgrm_bloc_home {
	
	var $slug	= 'bloc_home';
	
	var $trad	= '';
	
	var $cur_lng	= '';
	
	var $nbr_col	= 3;
	
	function __construct()
	{
		global $mgrm_lng;
		
		$this->cur_lng	= $mgrm_lng->cur_lng;
		
		
		// --- Traductions
		
		$this->trad	= new StdClass();
		$this->trad->front_title		= 'A la une';
		
		$this->trad->admin_title		= 'Blocs home';
		
		$this->trad->btn_lnkblank		= "Ouvrir dans une nouvelle fenêtre/onglet";
		$this->trad->btn_img			= "Sélectionner une photo";
		
		
		// --- Actions
		
		// Admin
		add_action( 'admin_enqueue_scripts', array( $this, 'add_admin_js_css' ) );
		add_action( 'admin_menu', array( $this, 'add_admin_menu' ) );
		
		// Front
		//add_action( 'wp_enqueue_scripts', array( $this, 'add_front_js_css' ) );
		add_action( 'mgrm_bloc_home', array( $this, 'front_display' ) );
	}
	
	
	function add_admin_js_css( $current_screen )
	{
		global $mgrm_infos;
		//print $current_screen;
		if ( $current_screen == sanitize_title( !empty( $mgrm_infos->site_title ) ? $mgrm_infos->site_title : get_bloginfo( 'sitename' ) ).'_page_'.$this->slug."_admin_page" )
		{
			$path = get_stylesheet_directory_uri().'/custom/'.$this->slug;
			
			wp_enqueue_style( 'mgrm_'.$this->slug, $path.'/css/admin.css', array(), null );
			
			wp_enqueue_script('jquery');
			
			wp_enqueue_media();
			
			wp_enqueue_script( 'mgrm_'.$this->slug, $path.'/js/admin.js', array('jquery'), null, false );
		}
	}
	
	
	function add_admin_menu()
	{
		global $mgrm_infos;
		
		add_submenu_page( $mgrm_infos->slug, $this->trad->admin_title, $this->trad->admin_title, 'delete_others_posts', $this->slug."_admin_page", array( $this, "add_admin_page" ) );
	}
	
	
	function add_admin_page()
	{
		if ( isset( $_POST['action'] ) && $_POST['action'] == 'update' )
		{			
			$message = $this->update_changes();
		}
		
		//delete_option( 'mgrm_'.$this->slug );
		
		$data	= get_option( 'mgrm_'.$this->slug );
	    $data	= json_decode( $data );
	    /*
	    print "<pre>";
	    print_r( $data );
	    print "</pre>";
	    */
		$data_count	= count( (array)$data );
		
		//print $data_count;
		
		$next_class	= $data_count == 0 ? ' disabled' : '';
		
		
		?>
		<div class="wrap">
			<h2>
				<?php echo $this->trad->admin_title; ?>
			</h2>
			<form action="" method="post">
				<input type="hidden" value="update" name="action">
				
				<table class="widefat">
					<thead>
						<tr>
							<?php for ( $i=1; $i<=$this->nbr_col; $i++ ) : ?>
							<th align="left" width="<?php echo 100/$this->nbr_col; ?>%"><h3>Bloc <?php echo $i; ?></h3></th>
							<?php endfor; ?>
						</tr>
					</thead>
					<tbody>
						
						<?php
						//for ( $i=0; $i<$data_count; $i++ ) : 
							
							//$alternate_class 	= !is_int( $i/2 ) ? ' class="alternate"' : '';
							//$next_class			= $i==$data_count-1 ? ' disabled' : '';
							
							?>
							<tr<?php //echo $alternate_class; ?>>
							<?php
							for ( $j=0; $j<$this->nbr_col; $j++ ) : 
							
								$page		= isset( $data->{$j}->page ) ? $data->{$j}->page : 0;
								$cat		= isset( $data->{$j}->cat ) ? $data->{$j}->cat : 0;
								$btn_txt	= stripslashes( isset( $data->{$j}->btn_txt ) ? $data->{$j}->btn_txt : '' );
								$texte		= stripslashes( isset( $data->{$j}->texte ) ? $data->{$j}->texte : '' );
								$img_id		= isset( $data->{$j}->img ) ? $data->{$j}->img : '';
								$img		= !empty( $img_id ) ? '<br><br>'.wp_get_attachment_image( $img_id, 'medium', false, array( 'id' => 'img_'.$img_id ) ) : '';
								
								?>
							
							<td>
								<p>
									Lien vers la page 
									<?php 
									$args	= array(
										'name'	=> 'page_'.$j.'_'.$this->cur_lng,
										'show_option_none' => __( 'Select' ),
										'selected'	=> $page
									);
									
									wp_dropdown_pages( $args );
									?>
									<br><strong>OU</strong>
									la catégorie 
									<?php 
									$args	= array(
										'name'	=> 'cat_'.$j.'_'.$this->cur_lng,
										'show_option_none' => __( 'Select' ),
										'selected'	=> $cat
									);
									
									wp_dropdown_categories( $args );
									?>
								</p>
								<p><?php wp_editor( $texte, 'texte_'.$j.'_'.$this->cur_lng, array( 'teeny' => true, 'media_buttons' => false, 'textarea_rows' => 5, 'textarea_name' => 'texte_'.$j.'_'.$this->cur_lng ) ); ?></p>
								<p>
									<input type="text" class="large-text" name="btn_txt_<?php echo $j; ?>_<?php echo $this->cur_lng; ?>" placeholder="Texte du bouton" value="<?php echo $btn_txt; ?>">
								</p>
								<p>
									<input type="button" class="button media-browser" value="<?php echo $this->trad->btn_img; ?>" />
									<input type="hidden" name="img_<?php echo $j; ?>_<?php echo $this->cur_lng; ?>" value="<?php echo $img_id; ?>">
									<?php echo $img; ?>
								</p>
							</td>
							<?php endfor; ?>
						</tr>
						<?php //endfor; ?>
						
						
					</tbody>
				</table>
				
				<p class="submit"><input id="submit" class="button button-primary" type="submit" value="<?php echo __('Save Changes'); ?>" name="submit"></p>
			</form>
		</div>
		<?php
	}
	
	
	function update_changes()
	{
		/*
		print "<pre>";
		print_r( $_POST );
		print "</pre>";
		*/
		
		$data	= new StdClass();
		
		$post		= $_POST;
		$post_count	= count( $post );
		$k			= 0;
		
		// Ligne par ligne
		//for ( $i=0; $i<$post_count; $i++ )
		//{
			// Colonne par colonne
			for ( $j=0; $j<$this->nbr_col; $j++ )
			{
				// Vérifier si la catégorie existe et qu'elle n'est pas vide
				//if ( isset( $post[ 'titre_'.$j.'_'.$this->cur_lng ] ) && !empty( $post[ 'titre_'.$j.'_'.$this->cur_lng ] ) )
				//{
					$item	= new StdClass();
					$item->page			= $post[ 'page_'.$j.'_'.$this->cur_lng ];
					$item->cat			= $post[ 'cat_'.$j.'_'.$this->cur_lng ];
					$item->btn_txt		= $post[ 'btn_txt_'.$j.'_'.$this->cur_lng ];
					$item->texte		= $post[ 'texte_'.$j.'_'.$this->cur_lng ];
					$item->img			= $post[ 'img_'.$j.'_'.$this->cur_lng ];
					
					$data->{$j}	= $item;
				//}
				
				//if ( isset( $data->{$k} ) && $j == $this->nbr_col )
				//{
				//	$k++;
				//}
			}
		//}
		/*
		print "<pre>";
		print_r( $data );
		print "</pre>";
		*/
		
	    $data	= json_encode( $data );
		$data	= update_option( 'mgrm_'.$this->slug, $data );
	}
	
	
	
	// Ajouter les css sur la partie publique
	function add_front_js_css()
	{
		$path = get_stylesheet_directory_uri().'/custom/'.$this->slug;
		
		wp_enqueue_style( 'mgrm_'.$this->slug, $path.'/css/front.css', array(), null );
	}
	
	
	function front_display( $bloc_nbr )
	{
		
		$data	= get_option( 'mgrm_'.$this->slug );
	    $data	= json_decode( $data );
	    
		$data_count	= count( (array)$data );
		
		//print "<pre>";
		//print_r( $data );
		//print "</pre>";
		
		$bloc_nbr = 0;
		
		//print count( (array)$data->{'0'} );
		
		if ( !empty( $data ) )
		{
			?>
			<div id="<?php echo $this->slug; ?>"><div class="container"><div class="row"><div class="row-height">
			<?php
			foreach( $data as $bloc )
			{
				// Ne pas afficher si la première rangée n'est pas complpète.
				if ( isset( $bloc ) && !empty( $bloc ) )
				{
					$page		= $bloc->page;
					$cat		= $bloc->cat;
					$btn_txt	= $bloc->btn_txt;
					
					if ( !empty( $page ) )
					{
						$post	= get_post( $page );
						
						$titre	= $post->post_title;
						$link	= get_post_permalink( $post->ID );
						
					}else if ( !empty( $cat ) )
					{
						$cat	= get_category( $cat );
						
						$titre	= $cat->name;
						$link	= get_category_link( $cat );
					}
					
					$img		= wp_get_attachment_image( $bloc->img, 'medium' );
					$text		= $bloc->texte;
					
					?>
					<div id="<?php echo $this->slug.'-'.$bloc_nbr; ?>" class="<?php echo $this->slug; ?> col-sm-4 col-height">
						<p class="post-title"><?php echo $titre; ?></p>
						<div class="post-img"><?php echo !empty( $img ) ? $img : ''; ?></div>
						<div class="post-content">
							<?php echo $text; ?>
							<p class="link"><a class="btn btn-default" href="<?php echo $link; ?>"><?php echo $btn_txt; ?></a></p>
						</div>
					</div>
					<?php
					
					$bloc_nbr++;
				}
			}
			?>
			</div></div></div></div>
			<?php
		}
	}
}