<?php

$mgrm_galleries		= new mgrm_galleries;

class mgrm_galleries {
	
	var $slug			= "galleries";
	
	function __construct()
	{
		add_action( 'wp_enqueue_scripts', array( $this, 'front_js_css' ) );
		add_filter( 'post_gallery', array( $this, 'custom_post_gallery'), 10, 2 );
		
		//add_action( 'edit_post', array( $this, 'check_save_gallery' ) );
		//add_action( 'post_save', array( $this, 'check_save_gallery' ) );
		//add_action( 'delete_post', array( $this, 'remove_gallery' ) );
		
		//add_shortcode( 'mgrm-galleries', array( $this, 'display_all_galleries' ) );
	}
	
	
	function front_js_css()
	{
		$path = get_template_directory_uri();
		
		wp_enqueue_script( 'jquery' );
		wp_enqueue_script( 'mgrm_'.$this->slug, $path.'/js/slimbox/js/slimbox2.js', array('jquery'), "", false );
		
		wp_enqueue_style( 'mgrm_'.$this->slug, $path.'/js/slimbox/css/slimbox2.css' );
	}
	
	
	// Ajoute/retire l'id du post dans l'option mgrm_posts_ac_galeries quand on enregistre un article
	function check_save_gallery( $pid )
	{
		//delete_option( 'mgrm_posts_ac_galeries' );
		if ( wp_is_post_revision( $pid ) )
			return;
		
		$post_content	= get_post_field( 'post_content', $pid );
		
		$has_gallery	= strpos( $post_content, "[gallery " );
		//update_option( 'mgrm_posts_ac_galeries', $has_gallery );
		
		$posts_ac_galeries	= get_option( 'mgrm_posts_ac_galeries' );
		if ( !empty( $posts_ac_galeries ) )
		{
			//update_option( 'mgrm_posts_ac_galeries', 'not empty '.$has_gallery );
			$posts_ac_galeries	= json_decode( $posts_ac_galeries );
		}else{
			//update_option( 'mgrm_posts_ac_galeries', 'empty '.$has_gallery );
			$posts_ac_galeries	= array();
		}
		
		if ( $has_gallery !== false )
		{
			// Ajouter l'id du post dans une variable option qui contient tout les id des articles avec galerie
			if ( !in_array( $pid, $posts_ac_galeries ) )
			{
				array_unshift( $posts_ac_galeries, $pid );
				//$posts_ac_galeries[]	= $pid;
				
				$posts_ac_galeries	= json_encode( $posts_ac_galeries );
				update_option( 'mgrm_posts_ac_galeries', $posts_ac_galeries );
			}
		}else{
			
			// Retirer l'id si il n'y a pas de galerie dans l'article
			if ( in_array( $pid, $posts_ac_galeries ) )
			{
				$key = array_search( $pid, $posts_ac_galeries );
				unset( $posts_ac_galeries[$key] );
				
				$posts_ac_galeries	= json_encode( $posts_ac_galeries );
				update_option( 'mgrm_posts_ac_galeries', $posts_ac_galeries );
			}
		}
	}
	
	
	function remove_gallery( $pid )
	{
		$posts_ac_galeries	= get_option( 'mgrm_posts_ac_galeries' );
		$posts_ac_galeries	= json_decode( $posts_ac_galeries );
		
		if ( in_array( $pid, $posts_ac_galeries ) )
		{
			$key = array_search( $pid, $posts_ac_galeries );
			unset( $posts_ac_galeries[$key] );
			
			$posts_ac_galeries	= json_encode( $posts_ac_galeries );
			update_option( 'mgrm_posts_ac_galeries', $posts_ac_galeries );
		}
	}
	
	
	// Change l'html des galeries
	function custom_post_gallery ( $output, $attr )
	{
		global $post, $wp_locale;
		
		static $instance = 0;
	    $instance++;
	    
	    $nbr_img_ligne	= 6;
	
	    // We're trusting author input, so let's at least make sure it looks like a valid orderby statement
	    if ( isset( $attr['orderby'] ) ) {
	        $attr['orderby'] = sanitize_sql_orderby( $attr['orderby'] );
	        if ( !$attr['orderby'] )
	            unset( $attr['orderby'] );
	    }
	
	    extract(shortcode_atts(array(
	        'order'      => 'ASC',
	        'orderby'    => 'menu_order ID',
	        'id'         => $post->ID,
	        'itemtag'    => 'dl',
	        'icontag'    => 'dt',
	        'captiontag' => 'dd',
	        'columns'    => 3,
	        'size'       => 'thumbnail',
	        'include'    => '',
	        'exclude'    => ''
	    ), $attr));
	
	    $id = intval($id);
	    if ( 'RAND' == $order )
	        $orderby = 'none';
	
	    if ( !empty($include) ) {
	        $include = preg_replace( '/[^0-9,]+/', '', $include );
	        $_attachments = get_posts( array('include' => $include, 'post_status' => 'inherit', 'post_type' => 'attachment', 'post_mime_type' => 'image', 'order' => $order, 'orderby' => $orderby) );
	
	        $attachments = array();
	        foreach ( $_attachments as $key => $val ) {
	            $attachments[$val->ID] = $_attachments[$key];
	        }
	    } elseif ( !empty($exclude) ) {
	        $exclude = preg_replace( '/[^0-9,]+/', '', $exclude );
	        $attachments = get_children( array('post_parent' => $id, 'exclude' => $exclude, 'post_status' => 'inherit', 'post_type' => 'attachment', 'post_mime_type' => 'image', 'order' => $order, 'orderby' => $orderby) );
	    } else {
	        $attachments = get_children( array('post_parent' => $id, 'post_status' => 'inherit', 'post_type' => 'attachment', 'post_mime_type' => 'image', 'order' => $order, 'orderby' => $orderby) );
	    }
	
	    if ( empty($attachments) )
	        return '';
	
	    if ( is_feed() ) {
	        $output = "\n";
	        foreach ( $attachments as $att_id => $attachment )
	            $output .= wp_get_attachment_link($att_id, $size, true) . "\n";
	        return $output;
	    }
	
	    $itemtag = tag_escape($itemtag);
	    $captiontag = tag_escape($captiontag);
	    $columns = intval($columns);
	    $itemwidth = $columns > 0 ? floor(100/$columns) : 100;
	    $float = is_rtl() ? 'right' : 'left';
	
	    $selector = "gallery-{$instance}";
	
	    /*$output = apply_filters('gallery_style', "
	        <style type='text/css'>
	            #{$selector} {
	                margin: auto;
	            }
	            #{$selector} .gallery-item {
	                float: {$float};
	                margin-top: 10px;
	                text-align: center;
	                width: {$itemwidth}%;           }
	            #{$selector} img {
	                border: 2px solid #cfcfcf;
	            }
	            #{$selector} .gallery-caption {
	                margin-left: 0;
	            }
	        </style>
	        <!-- see gallery_shortcode() in wp-includes/media.php -->
	        <div id='$selector' class='gallery galleryid-{$id}'>");*/
	    $output = "<div id='$selector' class='gallery galleryid-{$id}'>";
		$output .= '<ul class="row">';
		
	    $i = 0;
	    foreach ( $attachments as $id => $attachment ) {
	        /*$link = isset($attr['link']) && 'file' == $attr['link'] ? wp_get_attachment_link($id, $size, false, false) : wp_get_attachment_link($id, $size, true, false);
			
	        $output .= "<{$itemtag} class='gallery-item'>";
	        $output .= "
	            <{$icontag} class='gallery-icon'>
	                $link
	            </{$icontag}>";
	        if ( $captiontag && trim($attachment->post_excerpt) ) {
	            $output .= "
	                <{$captiontag} class='gallery-caption'>
	                " . wptexturize($attachment->post_excerpt) . "
	                </{$captiontag}>";
	        }
	        $output .= "</{$itemtag}>";
	        if ( $columns > 0 && ++$i % $columns == 0 )
	            $output .= '<br style="clear: both" />';
	        */
	        
	        $link	= wp_get_attachment_image_src($id, 'large');
	        
	        if ( $i>0 && is_int( $i/$nbr_img_ligne ) )
			{
				$output .= '<li class="clearfix visible-xs-block visible-sm-block visible-md-block visible-lg-block"></li>';
			}
	        
	        $col_nbr	= 12/$nbr_img_ligne;
	        $col_xs_nbr	= $col_nbr*2;
	        
			$output	.= '<li class="col-xs-'.$col_xs_nbr.' col-sm-'.$col_nbr.'"><a href="'.$link[0].'" rel="lightbox[]">'.wp_get_attachment_image( $id, 'thumbnail' ).'</a></li>';
			
			$i++;
	    }
	
	    /*$output .= "
	            <br style='clear: both;' />
	        </div>\n";*/
	    $output	.= "</ul>
	    	<div class='clear'></div>
	    	</div>";
	
	    return $output;
	}
	
	
	// Récupère la première image et le nombre de photos
	function get_post_first_gallery_count_n_first_image( $post )
	{
		if ( ! $post = get_post( $post ) )
			return false;
		
		if ( ! has_shortcode( $post->post_content, 'gallery' ) )
			return false;
		
		if ( preg_match_all( '/' . get_shortcode_regex() . '/s', $post->post_content, $matches, PREG_SET_ORDER ) ) {
			if ( isset( $matches[0] ) )
			{
				$shortcode	= $matches[0];
				if ( 'gallery' === $shortcode[2] ) {
					$ids	= $shortcode[3];
					
					// Première image
					$first_img_src	= "";
					$gim_pos		= strpos( $ids, "=" )+1;
					$gim_char		= substr( $ids, $gim_pos, 1 );
					$gim_pos		= strpos( $ids, $gim_char )+1;
					$vir_pos		= strpos( $ids, "," );
					if ( $vir_pos === false )
					{
						$vir_pos	= strpos( $ids, $gim_char, $gim_pos );
					}
					
					if ( $gim_pos!==false && $vir_pos!==false )
					{
						$first_id		= substr( $ids, $gim_pos, $vir_pos-$gim_pos );
						$first_img_src	= wp_get_attachment_thumb_url( $first_id );
					}
					
					// Nombre d'images
					$imgs_count	= 0;
					$ids_count	= explode( ",", $ids );
					$ids_count	= count( $ids_count );
					$imgs_count	= $ids_count;
					
					return array( $first_img_src, $imgs_count );
				}
			}
		}
		return false;
	}
	
	
	// Afficher toutes les galeries
	function display_all_galleries()
	{
		$galleries_list	= "";
		$posts_ac_galeries	= $this->get_posts_ids_with_gallery();
		
		if ( !empty( $posts_ac_galeries ) )
		{
			$idx	= 0;
			foreach( $posts_ac_galeries as $pid )
			{
				// Titre
				$post_title	= get_post_field( 'post_title', $pid );
				
				// Première image
				$images_info	= $this->get_post_first_gallery_count_n_first_image( $pid );
				$img_src		= $images_info[0];
				
				// Nombre d'images
				$imgs_count		= $images_info[1];
				
				// Créer un lien vers l'article
				$permalink	= get_the_permalink( $pid );
				
				if ( $idx>0 && is_int( $idx/4 ) )
				{
					$galleries_list .= '<li class="clearfix visible-xs-block visible-sm-block visible-md-block visible-lg-block"></li>';
				}
				
				$galleries_list .= '<li class="col-xs-4 col-sm-3"><a href="'.$permalink.'" title="'.$post_title.'"><img src="'.$img_src.'" />'.$post_title.' <span>('.$imgs_count.')</span></a></li>';
				
				$idx++;
			}
			
			if ( !empty( $galleries_list ) )
			{
				$galleries_list	= '<div id="galleries" class="row"><ul>'.$galleries_list.'</ul><div class="clearfix"></div></div>';
			}
		}
		
		echo $galleries_list;
	}
	
	
	// Ajoute une liste des galleries du blog
	function preview_galleries( $nbr=6 )
	{
		$galleries_preview	= "";
		$posts_ac_galeries	= $this->get_posts_ids_with_gallery( $nbr );
		
		if ( !empty( $posts_ac_galeries ) )
		{
			$idx	= 0;
			foreach( $posts_ac_galeries as $pid )
			{
				
				if ( $idx < $nbr )
				{
					// Titre
					$post_title	= get_post_field( 'post_title', $pid );
					
					// Première image
					$images_info	= $this->get_post_first_gallery_count_n_first_image( $pid );
					$img_src		= $images_info[0];
					
					// Nombre d'images
					$imgs_count		= $images_info[1];
					
					// Créer un lien vers l'article
					$permalink	= get_the_permalink( $pid );
					
					if ( $idx>0 && is_int( $idx/3 ) )
					{
						$galleries_preview .= '<li class="clearfix visible-xs-block"></li>';
					}
					
					$galleries_preview .= '<li class="col-xs-4 col-sm-2"><a href="'.$permalink.'" title="'.$post_title.'"><img src="'.$img_src.'" />'.$post_title.' <span>('.$imgs_count.')</span></a></li>';
				}
				$idx++;
			}
			
			if ( !empty( $galleries_preview ) )
			{
				$galleries_preview	= '<ul>'.$galleries_preview.'</ul><div class="clearfix"></div>';
			}
		}
		
		echo $galleries_preview;
	}
	
	
	function get_posts_ids_with_gallery( $limit='' )
	{
		global $wpdb;
		
		$cur_lng	= mgrm_get_cur_lng_code();
		
		$posts_ac_galeries	= get_option( 'mgrm_posts_ac_galeries' );
		$posts_ac_galeries	= json_decode( $posts_ac_galeries );
		
		if ( empty( $posts_ac_galeries ) )
			return false;
		
		$where	= "";
		foreach( $posts_ac_galeries as $pid )
		{
			$where	.= "( p.ID = '$pid' AND p.ID = t.element_id ) OR ";
		}
		$where	= substr( $where, 0, -4);
		
		if ( !empty( $limit ) && is_int( $limit ) )
		{
			$limit	= "LIMIT 0,$limit";
		}else{
			$limit	= "";
		}
		
		$query	= "SELECT ID
		FROM $wpdb->posts as p, ".$wpdb->prefix."icl_translations as t
		WHERE ( $where )
		AND p.post_status = 'publish'
		AND t.language_code = '$cur_lng'
		AND ( t.element_type = 'post' OR t.element_type = 'post_post' )
		ORDER BY p.post_date DESC
		$limit";
		
		$ids	= $wpdb->get_results( $query );
		
		$ids_ordered = array();
		foreach( $ids as $id )
		{
			array_push( $ids_ordered, $id->ID );
		}
		
		return $ids_ordered;
	}
	
	
	// Vérifie si il y a des galleries sur le blog
	function has_galleries()
	{
		global $wpdb;
		
		$cur_lng	= mgrm_get_cur_lng_code();
		
		$posts_ac_galeries	= get_option( 'mgrm_posts_ac_galeries' );
		$posts_ac_galeries	= json_decode( $posts_ac_galeries );
		
		if ( empty( $posts_ac_galeries ) )
			return false;
		
		
		$where	= "";
		foreach( $posts_ac_galeries as $pid )
		{
			$where	.= "( p.ID = '$pid' AND p.ID = t.element_id ) OR ";
		}
		$where	= substr( $where, 0, -4);
		
		$query	= "SELECT ID
		FROM $wpdb->posts as p, ".$wpdb->prefix."icl_translations as t
		WHERE ( $where )
		AND p.post_status = 'publish'
		AND t.language_code = '$cur_lng'
		AND ( t.element_type = 'post' OR t.element_type = 'post_post' )";
		
		$ids	= $wpdb->get_results( $query );
		
		if ( empty( $ids ) )
			return false;
		
		return true;
	}
	
	
	// Récupérer le lien vers la page qui contient toutes les galeries
	function get_galleries_permalink()
	{
		global $wpdb;
		
		$cur_lng	= mgrm_get_cur_lng_code();
		
		$query	= "SELECT p.ID
		FROM $wpdb->posts as p, ".$wpdb->prefix."icl_translations as t
		WHERE p.post_type = 'page'
		AND p.post_status = 'publish'
		AND p.post_content LIKE '%[mgrm-galleries]%'
		AND p.ID = t.element_id
		AND t.language_code = '$cur_lng'
		AND ( t.element_type = 'page' OR t.element_type = 'post_page' )";
		
		$result	= $wpdb->get_var( $query );
		
		if ( empty( $result ) )
			return "";
		
		$lnk	= get_permalink( $result );
		
		return $lnk;
	}
	
	
	// 
	function get_galleries_title()
	{
		$cur_lng	= mgrm_get_cur_lng_code();
		
		$gal_title	= "Galeries";
		if ( $cur_lng == "nl" )
		{
			$gal_title	= "Galerijen";
			
		}else if ( $cur_lng == "en" )
		{
			$gal_title	= "Galleries";
		}
		
		return	$gal_title;
	}
}