<?php
	
$mgrm_infos = new mgrm_infos;

class mgrm_infos {
	
	var $slug	= 'infos';
	
	var $min_rights	= 'delete_others_pages';
	
	var $cur_lng	= "";
	
	// Construction de la classe
	function __construct()
	{
		global $mgrm_lng;
		
		$this->cur_lng		= $mgrm_lng->cur_lng;
		
		if ( is_admin() )
		{
			// Ajouter la page d'admin
			//add_action( 'admin_enqueue_scripts', array( $this, 'admin_js_css' ) );
			add_action( 'admin_menu', array( $this, 'add_admin_menu' ) );
		}
	}
	
	// Ajoute le js et css
	function admin_js_css( $current_screen )
	{
		if ( $current_screen == 'toplevel_page_mediablog' )
		{
			$path = plugin_dir_url( __FILE__ );
			
			//wp_enqueue_style( 'mgrm_'.$this->slug, $path.'css/custom.css' );
			
			wp_enqueue_script('jquery');
			wp_enqueue_media();
			wp_enqueue_script( 'mgrm_'.$this->slug, $path.'../js/'.$this->slug.'.js', array('jquery'), "", false );
		}
	}
	
	
	// Ajouter le menu dans l'admin
	function add_admin_menu ()
	{
		add_menu_page( get_bloginfo( 'name'), get_bloginfo( 'name'), $this->min_rights, $this->slug, array( $this, "admin_page" ), "", 100 );
		add_submenu_page( $this->slug, "Infos", "Infos", $this->min_rights, $this->slug, array( $this, "admin_page" ) );
	}
	
	
	// Affichage de la page d'admin
	function admin_page()
	{
		// Appeler la fonction pour enregistrer les changements
		if ( isset( $_POST['action'] ) && $_POST['action'] == 'update' )
		{
			$message = $this->update_changes();
		}
		
		// Récupérer les données
		$options	= get_option( 'mgrm_'.$this->slug );
		$options	= json_decode( $options );
		
		//$titre_site	= stripslashes( get_bloginfo( 'sitename' ) );
		//$desc_site	= stripslashes( get_bloginfo( 'description' ) );
		//if ( function_exists( 'pll_default_language' ) )
		//{
		$titre_site	= stripslashes( isset( $options->{$this->cur_lng}->blogname ) ? $options->{$this->cur_lng}->blogname : stripslashes( get_bloginfo( 'sitename' ) ) );
		$desc_site	= stripslashes( isset( $options->{$this->cur_lng}->blogdescription ) ? $options->{$this->cur_lng}->blogdescription : stripslashes( get_bloginfo( 'description' ) ) );
		//}
		$email		= stripslashes( isset( $options->{$this->cur_lng}->email ) ? $options->{$this->cur_lng}->email : '' );
		$tel		= stripslashes( isset( $options->{$this->cur_lng}->tel ) ? $options->{$this->cur_lng}->tel : '' );
		$fax		= stripslashes( isset( $options->{$this->cur_lng}->fax ) ? $options->{$this->cur_lng}->fax : '' );
		$adresse	= stripslashes( isset( $options->{$this->cur_lng}->adresse ) ? $options->{$this->cur_lng}->adresse : '' );
		$horaire	= stripslashes( isset( $options->{$this->cur_lng}->horaire ) ? $options->{$this->cur_lng}->horaire : '' );
		$horaire_exeption	= stripslashes( isset( $options->{$this->cur_lng}->horaire_exeption ) ? $options->{$this->cur_lng}->horaire_exeption : '' );
		$tva		= stripslashes( isset( $options->{$this->cur_lng}->tva ) ? $options->{$this->cur_lng}->tva : '' );
		
		$fb_url			= stripslashes( isset( $options->{$this->cur_lng}->fb_url ) ? $options->{$this->cur_lng}->fb_url : '' );
		$twitter_url	= stripslashes( isset( $options->{$this->cur_lng}->twitter_url ) ? $options->{$this->cur_lng}->twitter_url : '' );
		$twitter_pseudo	= stripslashes( isset( $options->{$this->cur_lng}->twitter_pseudo ) ? $options->{$this->cur_lng}->twitter_pseudo : '' );
		$googleplus_url	= stripslashes( isset( $options->{$this->cur_lng}->googleplus_url ) ? $options->{$this->cur_lng}->googleplus_url : '' );
		$youtube_url	= stripslashes( isset( $options->{$this->cur_lng}->youtube_url ) ? $options->{$this->cur_lng}->youtube_url : '' );
		
		$ga_code		= stripslashes( isset( $options->{$this->cur_lng}->ga_code ) ? $options->{$this->cur_lng}->ga_code : '' );
		
		?>
		<div class="wrap">
			<h2><?php echo get_bloginfo( 'sitename' ); ?></h2>
			<br>
			<form action="" method="post">
				<input type="hidden" value="update" name="action">
				<table class="widefat">
					<thead>
						<tr>
							<th><strong>Général</strong></th>
							<th></th>
						</tr>
					</thead>
					<tbody>
						<tr class="alternate">
							<th scope="row" valign="top"><label for="blogname">Titre du site</label></th>
							<td><input type="text" class="large-text" id="blogname" name="blogname" value="<?php echo $titre_site; ?>"></td>
						</tr>
						<tr>
							<th scope="row" valign="top"><label for="blogname">Slogan</label></th>
							<td><input type="text" class="large-text" id="blogdescription" name="blogdescription" value="<?php echo $desc_site; ?>"></td>
						</tr>
						<tr class="alternate">
							<th scope="row" valign="top"><label for="email">Email</label></th>
							<td><input type="text" class="large-text" id="email" name="email" value="<?php echo $email; ?>"></td>
						</tr>
						<tr>
							<th scope="row" valign="top"><label for="email">Téléphone</label></th>
							<td><input type="text" class="large-text" id="tel" name="tel" value="<?php echo $tel; ?>"></td>
						</tr>
						<tr class="alternate">
							<th scope="row" valign="top"><label for="email">Fax</label></th>
							<td><input type="text" class="large-text" id="fax" name="fax" value="<?php echo $fax; ?>"></td>
						</tr>
						<tr>
							<th scope="row" valign="top"><label for="adresse">Adresse</label></th>
							<td>
							<?php wp_editor( $adresse, 'adresse', array( 'teeny' => true, 'quicktags' => false, 'media_buttons' => false, 'textarea_rows' => 2, 'textarea_name' => 'adresse' ) ); ?>
							</td>
						</tr>
						<tr class="alternate">
							<th scope="row" valign="top"><label for="horaire">Horaire</label></th>
							<td>
							<?php wp_editor( $horaire, 'horaire', array( 'teeny' => true, 'quicktags' => false, 'media_buttons' => false, 'textarea_rows' => 5, 'textarea_name' => 'horaire' ) ); ?>
							</td>
						</tr>
						<tr>
							<th scope="row" valign="top"><label for="exception">Ouvertures exceptionnelles</label></th>
							<td><input type="text" class="large-text" id="exception" name="exception" value="<?php echo $horaire_exeption; ?>"></td>
						</tr>
						<tr class="alternate">
							<th scope="row" valign="top"><label for="email">Numéro de TVA</label></th>
							<td><input type="text" class="large-text" id="tva" name="tva" value="<?php echo $tva; ?>"></td>
						</tr>
					</tbody>
				</table>
				<br>
				<table class="widefat">
					<thead>
						<tr>
							<th><strong>Réseaux sociaux</strong></th>
							<th></th>
						</tr>
					</thead>
					<tbody>
						<tr class="alternate">
							<th scope="row" valign="top"><label for="fb_url">Facebook</label></th>
							<td><input class="large-text" type="text" id="fb_url" name="fb_url" placeholder="http://..." value="<?php echo $fb_url; ?>"></td>
						</tr>
						<tr>
							<th scope="row" valign="top"><label for="twitter_url">Twitter</label></th>
							<td><input class="large-text" type="text" id="twitter_url" name="twitter_url" placeholder="http://..." value="<?php echo $twitter_url; ?>">
							<input class="large-text" type="text" id="twitter_pseudo" name="twitter_pseudo" placeholder="@pseudo" value="<?php echo $twitter_pseudo; ?>"></td>
						</tr>
						<tr class="alternate">
							<th scope="row" valign="top"><label for="googleplus_url">Google+</label></th>
							<td><input class="large-text" type="text" id="googleplus_url" name="googleplus_url" placeholder="http://..." value="<?php echo $googleplus_url; ?>"></td>
						</tr>
						<tr>
							<th scope="row" valign="top"><label for="youtube_url">Youtube</label></th>
							<td><input class="large-text" type="text" id="youtube_url" name="youtube_url" placeholder="http://..." value="<?php echo $youtube_url; ?>"></td>
						</tr>
					</tbody>
				</table>
				<br>
				<table class="widefat">
					<thead>
						<tr>
							<th><strong>Google analytics <small>- <a href="http://www.google.com/analytics/" target="_blank">Voir les statistiques</a></small></strong></th>
							<th></th>
						</tr>
					</thead>
					<tbody>
						<tr class="alternate">
							<th scope="row" valign="top"><label for="ga_code">Code de suivi<br><small>Sans les balises : <?php echo htmlentities('<script type="text/javascript"></script>'); ?></small></label></th>
							<td><textarea class="large-text code" cols="100" rows="8" id="ga_code" name="ga_code"><?php echo $ga_code; ?></textarea></td>
						</tr>
					</tbody>
				</table>
				<p class="submit"><input id="submit" class="button button-primary" type="submit" value="Enregistrer les modifications" name="submit"></p>
			</form>
		</div>
		<?php
	}
	
	
	function update_changes()
	{
		$options	= get_option( 'mgrm_'.$this->slug );
		$options	= json_decode( $options );
		
		if ( function_exists( 'pll_default_language' ) )
		{
			if ( pll_default_language() == $this->cur_lng )
			{
				// Titre du site
				if ( isset( $_POST['blogname'] ) )
				{
					update_option( 'blogname', $_POST['blogname'] );
				}
				
				// Description du site
				if ( isset( $_POST['blogdescription'] ) )
				{
					update_option( 'blogdescription', $_POST['blogdescription'] );
				}
			}
		}else{
			// Titre du site
			if ( isset( $_POST['blogname'] ) )
			{
				update_option( 'blogname', $_POST['blogname'] );
			}
			
			// Description du site
			if ( isset( $_POST['blogdescription'] ) )
			{
				update_option( 'blogdescription', $_POST['blogdescription'] );
			}
		}
			
		// Titre du site
		$options->{$this->cur_lng}->blogname		= isset( $_POST['blogname'] ) ? $_POST['blogname'] : '';
		
		// Description du site
		$options->{$this->cur_lng}->blogdescription		= isset( $_POST['blogdescription'] ) ? $_POST['blogdescription'] : '';
		
		// Email
		$options->{$this->cur_lng}->email		= isset( $_POST['email'] ) ? $_POST['email'] : '';
		
		// Tel
		$options->{$this->cur_lng}->tel		= isset( $_POST['tel'] ) ? $_POST['tel'] : '';
		
		// Fax
		$options->{$this->cur_lng}->fax		= isset( $_POST['fax'] ) ? $_POST['fax'] : '';
		
		// Adresse
		$options->{$this->cur_lng}->adresse		= isset( $_POST['adresse'] ) ? wpautop( $_POST['adresse'] ) : '';
		
		// Horaires
		$options->{$this->cur_lng}->horaire		= isset( $_POST['horaire'] ) ? wpautop( $_POST['horaire'] ) : '';
		
		// Ouverture exceptionnelle
		$options->{$this->cur_lng}->horaire_exeption		= isset( $_POST['horaire_exeption'] ) ? $_POST['horaire_exeption'] : '';
		
		// TVA
		$options->{$this->cur_lng}->tva		= isset( $_POST['tva'] ) ? $_POST['tva'] : '';
		
		
		// Facebook
		$options->{$this->cur_lng}->fb_url		= isset( $_POST['fb_url'] ) ? $_POST['fb_url'] : '';
		
		// Twitter
		$options->{$this->cur_lng}->twitter_url		= isset( $_POST['twitter_url'] ) ? $_POST['twitter_url'] : '';
		$options->{$this->cur_lng}->twitter_pseudo		= isset( $_POST['twitter_pseudo'] ) ? $_POST['twitter_pseudo'] : '';
		
		// Google+
		$options->{$this->cur_lng}->googleplus_url		= isset( $_POST['googleplus_url'] ) ? $_POST['googleplus_url'] : '';
		
		// Youtube
		$options->{$this->cur_lng}->youtube_url		= isset( $_POST['youtube_url'] ) ? $_POST['youtube_url'] : '';
		
		
		// Google analytics
		$options->{$this->cur_lng}->ga_code		= isset( $_POST['ga_code'] ) ? $_POST['ga_code'] : '';
		
		$options	= json_encode( $options );
		update_option( 'mgrm_'.$this->slug, $options );
	}
	
	function get_info( $slug='' )
	{
		if ( empty( $slug ) )
			return;
		
		$mediablog_options	= get_option( 'mgrm_'.$this->slug );
	    $mediablog_options	= json_decode( $mediablog_options );
		
		if ( isset( $mediablog_options->{$this->cur_lng} ) )
		{
			if ( isset( $mediablog_options->{$this->cur_lng}->$slug ) )
			{
				if ( $slug == "adresse" || $slug == "horaire" || $slug == "parking" || $slug == "transport" )
				{
					return wpautop( stripslashes( $mediablog_options->{$this->cur_lng}->$slug ) );
				}
				return stripslashes( $mediablog_options->{$this->cur_lng}->$slug );
			}
			
			return stripcslashes( $mediablog_options->$slug );
		}else{
			return false;
		}
	}
}


// Récupérer une info
function mgrm_get_info ( $slug="" )
{
	if ( empty( $slug ) )
		return;
	
	global $mgrm_infos, $mgrm_lng;
	
	$options	= get_option( 'mgrm_'.$mgrm_infos->slug );
	$options	= json_decode( $options );
	
	$cur_lng		= $mgrm_lng->cur_lng;
	
	
	
	// Si c'est le nom du blog ou la description
	// Si l'options est vide, prendre la valeur normale de wordpress
	if ( $slug == 'blogname' && !isset( $options->{$cur_lng} ) && !isset( $options->{$cur_lng}->$slug ) )
	{
		return get_bloginfo( 'sitename' );
	}
	if ( $slug == 'blogdescription' && !isset( $options->{$cur_lng} ) && !isset( $options->{$cur_lng}->$slug ) )
	{
		return get_bloginfo( 'description' );
	}
	
	
	
	// Si la langue n'existe pas on annule
	if ( !isset( $options->{$cur_lng} ) )
		return;
	
	// Si la section n'existe pas on annule
	if ( !isset( $options->{$cur_lng}->$slug ) )
		return;

	$info	= stripslashes( $options->{$cur_lng}->$slug );
	
	if ( $slug == "adresse" || $slug == "horaire" || $slug == "parking" || $slug == "transport" )
	{
		$info = wpautop( $info );
	}
	
	// Si c'est l'email formater la réponse pour la fonction javascript
	if ( $slug == 'email' )
	{
		$last_dot_pos = strrpos( $info, '.' );
		if($last_dot_pos !== false)
	    {
	        $info = substr_replace( $info, '","', $last_dot_pos, 1 );
	    }
		
		$info	= str_replace( '@', '","', $info );
		$info	= '"'.$info.'"';
	}
	
	return $info;
}