<?php
	
/*
 * Plus d'infos : https://polylang.wordpress.com/documentation/documentation-for-developers/functions-reference/
 *
 */


// Enregistrer les textes fixes du thème
if ( function_exists( 'pll_the_languages' ) )
{
	pll_register_string( 'Texte lien facebook', 'Rejoignez nous sur facebook', 'Thème' );
	
	pll_register_string( 'Titre de colonne dans le pied de page', 'Contact', 'Thème' );
	pll_register_string( 'Titre de colonne dans le pied de page', 'Horaires', 'Thème' );
}


$mgrm_lng = new mgrm_lng;

class mgrm_lng {
	
	var $cur_lng	= '';
	var $active_lng	= '';
	
	// Construction de la classe
	function __construct()
	{
		// Current language
		$this->cur_lng	= substr( get_locale(), 0, 2 );
		
		if ( function_exists( 'pll_the_languages' ) )
		{
			$pll_cur_lng	= pll_current_language( "slug" );
			
			if ( !empty( $pll_cur_lng ) )
			{
				$this->cur_lng	= $pll_cur_lng;
			}	
		}
		
		
		// Active languages
		$this->active_lng	= array( $this->cur_lng );
		if ( function_exists( 'pll_the_languages' ) )
		{
			global $polylang;
	
			if ( isset( $polylang ) )
				$this->active_lng = $polylang->model->get_languages_list();
		}
	}
}

function mgrm_lng_menu( $separator="&nbsp;" )
{
	if ( !function_exists( 'pll_the_languages' ) )
		return;
	
	$args	= array(
		'display_names_as'	=> 'slug',
		'echo'	=> 0,
		'hide_if_empty'	=> 0
	);
	
	$translations	= pll_the_languages( $args );
	
	if ( !empty( $translations ) )
		$translations	= '<li class="separator">'.$separator.'</li>'.$translations;
	
	echo $translations;
}

/*function mgrm_current_lng( $value="" )
{
	if ( function_exists( 'pll_the_languages' ) )
	{
		$value		= empty( $value ) ? "slug" : $value;
		$cur_lng	= pll_current_language( $value );
		
	}else{
		$cur_lng	= substr( get_locale(), 0, 2 );
	}
	return $cur_lng;
}*/

/*function mgrm_active_lng()
{
	if ( function_exists( 'pll_the_languages' ) )
	{
		global $polylang;

		if ( isset( $polylang ) )
			$translations = $polylang->model->get_languages_list();

	}else{
		$translations	= array( mgrm_current_lng() );
	}
	
	return $translations;
}*/